Create Or Update Custom Resource Type

Create Or Update Custom Resource Type
Create custom resource type.

Create custom resource type.

Request
URI
POST
https://vcf-stls-wcp-pod13-137.lvn.broadcom.net/form-service/api/custom/resource-types
COPY
Request Body
CustomResourceType of type(s) application/json
Required
{
    "id": "string",
    "displayName": "string",
    "description": "string",
    "resourceType": "string",
    "externalType": "string",
    "status": "string",
    "orgId": "string",
    "projectId": "string",
    "mainActions": {
        "allocate": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            {
                                "label": "string",
                                "description": "string",
                                "signpost": "string",
                                "type": "FormSchemaFieldType Object",
                                "step": "number",
                                "default": {},
                                "valueList": {},
                                "placeholder": "string",
                                "constraints": {
                                    "matchConstraint": {
                                        "match": {}
                                    },
                                    "constraints": {
                                        "constraints": {}
                                    }
                                },
                                "refresh": {
                                    "type": "string"
                                },
                                "shortValueName": [
                                    "string"
                                ],
                                "id": "string",
                                "valueTree": {}
                            }
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": {
                        "actionName": "string",
                        "actionInputs": [
                            "Binding Object"
                        ]
                    }
                }
            ]
        },
        "create": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        },
        "read": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        },
        "update": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        },
        "delete": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        }
    },
    "additionalActions": [
        {
            "id": "string",
            "name": "string",
            "displayName": "string",
            "description": "string",
            "providerName": "string",
            "resourceType": "string",
            "status": "string",
            "projectId": "string",
            "orgId": "string",
            "runnableItem": {
                "id": "string",
                "name": "string",
                "description": "string",
                "projectId": "string",
                "type": "string",
                "inputParameters": [
                    {
                        "type": "string",
                        "name": "string",
                        "description": "string"
                    }
                ],
                "outputParameters": [
                    {
                        "type": "string",
                        "name": "string",
                        "description": "string"
                    }
                ],
                "endpointLink": "string",
                "inputBindings": [
                    {
                        "inputKey": "string",
                        "value": "string",
                        "type": {
                            "dataType": "string",
                            "referenceType": "string",
                            "fields": [
                                "ComplexTypeField Object"
                            ],
                            "isMultiple": false
                        },
                        "bindingAction": "BindingAction Object"
                    }
                ]
            },
            "formDefinition": {
                "tenant": "string",
                "id": "string",
                "name": "string",
                "form": "string",
                "styles": "string",
                "sourceType": "string",
                "sourceId": "string",
                "type": "string",
                "status": "string",
                "createdDate": "string",
                "modifiedDate": "string",
                "formFormat": "string",
                "providerRef": "string",
                "externalSourceFormSchemas": [
                    {
                        "externalSourceId": "string",
                        "parentId": "string",
                        "elementId": "string",
                        "elementType": "string",
                        "facet": "string",
                        "parameters": [
                            {
                                "validatable": false,
                                "name": "string",
                                "isValidatable": false
                            }
                        ]
                    }
                ]
            },
            "criteria": {
                "matchExpression": [
                    {}
                ]
            }
        }
    ],
    "properties": {
        "type": "string",
        "encrypted": false,
        "additionalProperties": false,
        "title": "string",
        "description": "string",
        "writeOnly": false,
        "readOnly": false,
        "anyOf": [
            {
                "type": "string",
                "encrypted": false,
                "additionalProperties": false,
                "title": "string",
                "description": "string",
                "writeOnly": false,
                "readOnly": false,
                "anyOf": [
                    "ProviderSchemaImpl Object"
                ],
                "oneOf": [
                    "ProviderSchemaImpl Object"
                ],
                "not": "ProviderSchemaImpl Object",
                "items": {
                    "value": "ProviderSchemaImpl Object",
                    "singleton": false,
                    "values": [
                        "ProviderSchemaImpl Object"
                    ]
                },
                "uniqueItems": false,
                "maxItems": 0,
                "minItems": 0,
                "maximum": "number",
                "minimum": "number",
                "properties": {
                    "properties": "ProviderSchemaImpl Object"
                },
                "required": [
                    "string"
                ],
                "maxProperties": 0,
                "minProperties": 0,
                "patternProperties": {
                    "patternProperties": "ProviderSchemaImpl Object"
                },
                "maxLength": 0,
                "minLength": 0,
                "pattern": "string",
                "format": "string",
                "formatMinimum": "string",
                "formatMaximum": "string",
                "computed": false,
                "recreateOnUpdate": false,
                "ignoreOnUpdate": false,
                "ignoreCaseOnDiff": false,
                "dependencies": {
                    "dependencies": [
                        "string"
                    ]
                },
                "enum": [
                    {}
                ],
                "const": {},
                "default": {},
                "$data": "string",
                "$dynamicDefault": "string",
                "metadata": {
                    "metadata": {}
                }
            }
        ],
        "oneOf": [
            "ProviderSchemaImpl Object"
        ],
        "not": "ProviderSchemaImpl Object",
        "items": "ObjectOrListProviderSchemaImpl Object",
        "uniqueItems": false,
        "maxItems": 0,
        "minItems": 0,
        "maximum": "number",
        "minimum": "number",
        "properties": {
            "properties": "ProviderSchemaImpl Object"
        },
        "required": [
            "string"
        ],
        "maxProperties": 0,
        "minProperties": 0,
        "patternProperties": {
            "patternProperties": "ProviderSchemaImpl Object"
        },
        "maxLength": 0,
        "minLength": 0,
        "pattern": "string",
        "format": "string",
        "formatMinimum": "string",
        "formatMaximum": "string",
        "computed": false,
        "recreateOnUpdate": false,
        "ignoreOnUpdate": false,
        "ignoreCaseOnDiff": false,
        "dependencies": {
            "dependencies": [
                "string"
            ]
        },
        "enum": [
            {}
        ],
        "const": {},
        "default": {},
        "$data": "string",
        "$dynamicDefault": "string",
        "metadata": {
            "metadata": {}
        }
    },
    "schemaType": "string",
    "propertyBindings": {
        "readPropertyBindings": [
            {
                "schemaPropertyName": "string",
                "workflowInputOrOutputName": "string"
            }
        ],
        "updatePropertyBindings": [
            {
                "schemaPropertyName": "string",
                "workflowInputOrOutputName": "string"
            }
        ],
        "deletePropertyBindings": [
            {
                "schemaPropertyName": "string",
                "workflowInputOrOutputName": "string"
            }
        ]
    },
    "propertiesYaml": "string"
}
string As uuid As uuid
id
Optional

id

string
displayName
Optional

displayName

string
description
Optional

description

string
resourceType
Optional

resourceType

string
externalType
Optional

externalType

string
status
Optional

status

Possible values are : released, draft,
string
orgId
Optional

orgId

string
projectId
Optional

projectId

object
mainActions
Optional

mainActions

array of object
additionalActions
Optional

The resource action

object
properties
Optional

properties

string
schemaType
Optional

schemaType

object
propertyBindings
Optional

propertyBindings

string
propertiesYaml
Optional

propertiesYaml

Authentication
This operation uses the following authentication methods.
Responses
200

'Success' with created or updated custom resource type

Returns CustomResourceType of type(s) */*
{
    "id": "string",
    "displayName": "string",
    "description": "string",
    "resourceType": "string",
    "externalType": "string",
    "status": "string",
    "orgId": "string",
    "projectId": "string",
    "mainActions": {
        "allocate": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        },
        "create": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        },
        "read": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        },
        "update": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        },
        "delete": {
            "id": "string",
            "name": "string",
            "description": "string",
            "projectId": "string",
            "type": "string",
            "inputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "outputParameters": [
                {
                    "type": "string",
                    "name": "string",
                    "description": "string"
                }
            ],
            "endpointLink": "string",
            "inputBindings": [
                {
                    "inputKey": "string",
                    "value": "string",
                    "type": {
                        "dataType": "string",
                        "referenceType": "string",
                        "fields": [
                            "ComplexTypeField Object"
                        ],
                        "isMultiple": false
                    },
                    "bindingAction": "BindingAction Object"
                }
            ]
        }
    },
    "additionalActions": [
        {
            "id": "string",
            "name": "string",
            "displayName": "string",
            "description": "string",
            "providerName": "string",
            "resourceType": "string",
            "status": "string",
            "projectId": "string",
            "orgId": "string",
            "runnableItem": {
                "id": "string",
                "name": "string",
                "description": "string",
                "projectId": "string",
                "type": "string",
                "inputParameters": [
                    {
                        "type": "string",
                        "name": "string",
                        "description": "string"
                    }
                ],
                "outputParameters": [
                    {
                        "type": "string",
                        "name": "string",
                        "description": "string"
                    }
                ],
                "endpointLink": "string",
                "inputBindings": [
                    {
                        "inputKey": "string",
                        "value": "string",
                        "type": {
                            "dataType": "string",
                            "referenceType": "string",
                            "fields": [
                                "ComplexTypeField Object"
                            ],
                            "isMultiple": false
                        },
                        "bindingAction": "BindingAction Object"
                    }
                ]
            },
            "formDefinition": {
                "tenant": "string",
                "id": "string",
                "name": "string",
                "form": "string",
                "styles": "string",
                "sourceType": "string",
                "sourceId": "string",
                "type": "string",
                "status": "string",
                "createdDate": "string",
                "modifiedDate": "string",
                "formFormat": "string",
                "providerRef": "string",
                "externalSourceFormSchemas": [
                    {
                        "externalSourceId": "string",
                        "parentId": "string",
                        "elementId": "string",
                        "elementType": "string",
                        "facet": "string",
                        "parameters": [
                            {
                                "validatable": false,
                                "name": "string",
                                "isValidatable": false
                            }
                        ]
                    }
                ]
            },
            "criteria": {
                "matchExpression": [
                    {}
                ]
            }
        }
    ],
    "properties": {
        "type": "string",
        "encrypted": false,
        "additionalProperties": false,
        "title": "string",
        "description": "string",
        "writeOnly": false,
        "readOnly": false,
        "anyOf": [
            "ProviderSchemaImpl Object"
        ],
        "oneOf": [
            "ProviderSchemaImpl Object"
        ],
        "not": "ProviderSchemaImpl Object",
        "items": "ObjectOrListProviderSchemaImpl Object",
        "uniqueItems": false,
        "maxItems": 0,
        "minItems": 0,
        "maximum": "number",
        "minimum": "number",
        "properties": {
            "properties": "ProviderSchemaImpl Object"
        },
        "required": [
            "string"
        ],
        "maxProperties": 0,
        "minProperties": 0,
        "patternProperties": {
            "patternProperties": "ProviderSchemaImpl Object"
        },
        "maxLength": 0,
        "minLength": 0,
        "pattern": "string",
        "format": "string",
        "formatMinimum": "string",
        "formatMaximum": "string",
        "computed": false,
        "recreateOnUpdate": false,
        "ignoreOnUpdate": false,
        "ignoreCaseOnDiff": false,
        "dependencies": {
            "dependencies": [
                "string"
            ]
        },
        "enum": [
            {}
        ],
        "const": {},
        "default": {},
        "$data": "string",
        "$dynamicDefault": "string",
        "metadata": {
            "metadata": {}
        }
    },
    "schemaType": "string",
    "propertyBindings": {
        "readPropertyBindings": [
            {
                "schemaPropertyName": "string",
                "workflowInputOrOutputName": "string"
            }
        ],
        "updatePropertyBindings": [
            {
                "schemaPropertyName": "string",
                "workflowInputOrOutputName": "string"
            }
        ],
        "deletePropertyBindings": [
            {
                "schemaPropertyName": "string",
                "workflowInputOrOutputName": "string"
            }
        ]
    },
    "propertiesYaml": "string"
}

400

'Bad Request' if CustomResourceType is not in specified format

Operation doesn't return any data structure

403

'Forbidden' no custom resource managing rights

Operation doesn't return any data structure

Code Samples
COPY
                    curl -X POST -H 'Authorization: <value>' -H 'Content-Type: application/json' -d '{}' https://{api_host}/form-service/api/custom/resource-types